%define anolis_release 3
%define debug_package %{nil}
%global kernel 5.10.134-17.an23 
%global pkg udma
%global pkg_version 0.1.0

Name:       kmod-%{pkg}-%(echo %{kernel} | sed -E 's/\.(an|al)[0-9]+$//g')
Version:    %{pkg_version}
Release:    %{anolis_release}%{?dist}
Summary:    Driver for UDMA
License:    GPLv2
URL:        https://gitee.com/anolis/kmod-udma

Source0:    kmod-%{pkg}-%{pkg_version}.tar.gz

Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:      gcc gcc-c++ make
Provides:         kmod-intel-QAT20 = %{version}-%{release}
Obsoletes:        kmod-intel-QAT20 < %{version}-%{release}
Obsoletes:        kmod-intel-QAT20 < %{version}-%{release}.%{anolis_release}%{?dist}
Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}
ExclusiveArch:      x86_64

%description
kmod-udma is responsible for pin DMA memory for userspace.
It is the kernel driver for UDMA.

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build

%install
KERNEL_VER=%{kernel}.%{_arch}
mkdir -p %{buildroot}/lib/modules/${KERNEL_VER}/extra/udma
%{__install} -D -t %{buildroot}/lib/modules/${KERNEL_VER}/extra/udma/ src/%{_arch}/lib/modules/${KERNEL_VER}/kernel/udma_drv.ko

find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%post
ECHO=/usr/bin/echo
${ECHO} "Creating module.dep file for UDMA"
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/udma/udma_drv.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/udma/udma_drv.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi

rm /var/run/rpm-%{pkg}-modules.list

%files
/lib/modules/%{kernel}.%{_arch}/extra/udma/udma_drv.ko
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Fri Nov 24 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-2
- Some typo fix

* Mon Nov 13 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-1
- Change spec for oot weak module

* Mon Aug 21 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-1
- Init package
